<?php
/* tabstop=4 tabreplace=space */
/**
 * Joomla-SMF Forum
 *
 * This file is used for the backend installation and configuration that
 * is accessed via Components->Joomla-SMF Forum->Configuration
 *
 * LICENSE: This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
 *
 * @category    Component
 * @package     com_smf
 * @author      Cowboy <ross@joomlahacks.com>
 * @author      Wolverine <joshualross@gmail.com>
 * @copyright   (C) JoomlaHacks.com. All rights reserved.
 * @license     http://www.gnu.org/copyleft/gpl.html GNU/GPL
 * @version     $Id: smf.class.php 385 2007-01-28 03:56:14Z joshualross $
 * @revision    $LastChangedRevision: 385 $
 * @date        $LastChangedDate: 2007-01-27 22:56:14 -0500 (Sat, 27 Jan 2007) $
 * @file        $HeadURL: http://scm.joomla.org/svn/repos/joomla-smf_2_0/trunk/smf.class.php $
 * @link        http://www.JoomlaHacks.com
 * @link        http://www.joshualross.us
 * @since       File available since Release 2.0
 *
 * Visit JoomlaHacks.com for more Joomla Hacks!
 */
//no direct access
defined( '_VALID_MOS' ) or die( 'Restricted access' );
global $mosConfig_absolute_path;
defined('JPATH_BASE') or define('JPATH_BASE', $mosConfig_absolute_path);
/**
 * Include the jsmfAdmin class
 */
require_once JPATH_BASE . DIRECTORY_SEPARATOR . 'administrator' . DIRECTORY_SEPARATOR
                        . 'components' . DIRECTORY_SEPARATOR . 'com_smf' . DIRECTORY_SEPARATOR . 'admin.smf.class.php';

if (!defined('JSMFADMIN_BASE')) {
    /** #@+
     * Constants
     */
    /**
     * JSMFADMIN_BASE
     */
    define('JSMFADMIN_BASE', JPATH_BASE . DIRECTORY_SEPARATOR . 'administrator' . DIRECTORY_SEPARATOR . 'components'
                                        . DIRECTORY_SEPARATOR . 'com_smf');
    /** #@- */
}

/**
 * Joomla-SMF frontend functionality
 *
 * @package com_smf
 */
class jsmfFrontend extends jsmfAdmin{

    /**
     * this tracks if sef has been changed
     *
     * @var boolean $sef_status
     */
    var $sef_status = FALSE;

    /**
     * this tracks if jsmf configs changed
     *
     * @var int $last_modified
     */
    var $last_modified = 0;


    /**
     * debug output
     *
     * @var string $debug
     */
    var $debug = '';
    
    var $is_set = FALSE;
    
    /**
     * Singleton
     *
     *
     * @access public
     * @return class instance
     * @global boolean $mosConfig_offline
     */
    function & singleton()
    {
        global $mosConfig_offline;

        $inst_name = "_INSTANCE_" . strtoupper(__CLASS__);

        if ($mosConfig_offline == 1) {
            $jsmf =& new jsmfFrontend();
            return $jsmf;
        }

        if (isset($_SESSION))
        {
            if (!isset($_SESSION[$inst_name])) {
                $_SESSION[$inst_name] =& new jsmfFrontend();
            }
            return $_SESSION[$inst_name];
        } else {
            if (!isset($GLOBALS[$inst_name])) {
                $GLOBALS[$inst_name] =& new jsmfFrontend();
            }
            return $GLOBALS[$inst_name];
        }
    }


    /**
     * Saves the environment before SMF's SSI has been included
     *
     *
     * @access public
     * @param array reference $arr
     * @return n/a
     */
    function saveVars(&$arr)
    {
        $arr['REQUEST'] = $_REQUEST;
        $arr['POST']    = $_POST;
        $arr['COOKIE']  = $_COOKIE;
        $arr['GET']     = $_GET;
        $arr['SERVER']  = $_SERVER;
        $arr['FILES']   = $_FILES;
        if(isset($GLOBALS['HTTP_POST_VARS'])) {
            $arr['HTTP_POST_VARS']     = $GLOBALS['HTTP_POST_VARS'];
        }
        if(isset($GLOBALS['HTTP_POST_FILES'])) {
            $arr['HTTP_POST_FILES']    = $GLOBALS['HTTP_POST_FILES'];
        }
    }

    /**
     * Restores the environment after SMF's SSI has been included
     *
     *
     * @access public
     * @param array reference $arr
     * @return n/a
     */
    function restoreVars(&$arr)
    {
        $_REQUEST   = $arr['REQUEST'];
        $_POST      = $arr['POST'];
        $_COOKIE    = $arr['COOKIE'];
        $_GET       = $arr['GET'];
    	$_SERVER    = $arr['SERVER'];
        $_FILES		= $arr['FILES'];
        if(isset($arr['HTTP_POST_VARS'])) {
            $GLOBALS['HTTP_POST_VARS']    = $arr['HTTP_POST_VARS'];
        }
        if(isset($arr['HTTP_POST_FILES'])) {
            $GLOBALS['HTTP_POST_FILES']   = $arr['HTTP_POST_FILES'];
        }
    }

    /**
     * Restores the $_POST message after SMF's SSI has been included
     *
     *
     * @access public
     * @param array reference $arr
     * @return n/a
     */
    function restorePostMessage(&$arr)
    {
        if (isset($_POST['message'])) {
            $_POST['message'] = $arr['POST']['message'];
        }
        unset($arr);
    }



    /**
     * The workhorse, this method searches and replaces all URLs necessary for the integration
     *
     *
     * @access public
     * @param string reference $buffer
     * @return n/a
     * @global string $mosConfig_live_site
     * @global boolean $mosConfig_sef
     * @global database $database Joomla database handle
     * @global boolean $mosConfig_debug
     * @global object $mainframe
     * @global string $boardurl SMF board url
     * @global string $scripturl SMF script url
     * @global object $jsmfConfig Joomla-SMF Forum configurations
     */
    function fixBuffer(&$buffer)
    {
        global $mosConfig_live_site, $mosConfig_sef, $database, $mosConfig_debug, $mainframe;
        global $boardurl, $scripturl, $context;
        global $jsmfConfig, $jsmfCache;
        $code = $jsmfConfig->code;
        if ($jsmfConfig->debug || $mosConfig_debug) {
            include_once JSMFADMIN_BASE . DIRECTORY_SEPARATOR . 'includes' . DIRECTORY_SEPARATOR . 'Timer.php';
            $this->debug .= '<hr /><table><tr><th colspan="2"><center>DEBUG</center></th></tr>';
            $this->debug .= '<tr><td colspan="2"><hr /></td></tr>';
            $timer = new Benchmark_Timer();
            $timer->start();
        }

        if (!$this->is_set) {
        	$this->sef_status = $mosConfig_sef;
            $this->last_modified = $jsmfConfig->last_modified;
            $this->is_set = TRUE;
        }
        if ($this->sef_status != $mosConfig_sef || $jsmfConfig->last_modified > $this->last_modified) {
        	$this->debug .= '<tr><td colspan="2">CLEAR</td></tr>';
            $this->sef_status = $mosConfig_sef;
            $this->last_modified = $jsmfConfig->last_modified;
            if ($jsmfConfig->caching) {
                $jsmfCache->remove('buffer_cache');
                $jsmfCache->remove('headers');
                $jsmfCache->remove('keywords');
                if ($jsmfConfig->cache_css) {
                   $jsmfCache->remove('css'); 
                }
                $jsmfCache->clean();
                //if we clean, reload jsmfConfig?
                $jsmfConfig = $this->loadParams();
            }
        }

//        if (($cache_search  = $jsmfCache->get('search')) === FALSE && ($jsmfConfig->debug || $mosConfig_debug)) {
//        	$this->debug .= "Error loading search cache<br />";
//        }
//        if (($cache_replace = $jsmfCache->get('replace')) === FALSE && ($jsmfConfig->debug || $mosConfig_debug)) {
//        	$this->debug .= "Error loading replace cache<br />";
//        }
        $cache_search  = array();
        $cache_replace = array();
        if ($jsmfConfig->caching) {
            $buffer_cache = new stdClass();
            if (($buffer_cache = $jsmfCache->get('buffer_cache')) == FALSE && ($jsmfConfig->debug || $mosConfig_debug)) {
            	$this->debug .= "Error loading buffer cache<br />";
            }
            if (isset($buffer_cache->search)) {
                $cache_search = $buffer_cache->search;
            }
            if (isset($buffer_cache->replace)) {
                $cache_replace = $buffer_cache->replace;
            }
            unset($buffer_cache);
        }
        
        if (!$jsmfConfig->caching || empty($cache_search) || empty($cache_replace)) {
            $cache_search = array();
            $cache_replace = array();
            if ($jsmfConfig->debug || $mosConfig_debug) {
                $this->debug .= '<tr><td colspan="2">SMF BUFFER ARRAYS EMPTY -- REBUILDING</td></tr>';
                $this->debug .= '<tr><td colspan="2"><hr /></td></tr>';
            }

            switch ($jsmfConfig->reg_module) {
                case "cb":
                case "cbe":
                    if ($jsmfConfig->add_itemid && ($itemid = $this->getComponentId('Community Builder'))) {
                        $registration_link = 'index.php?option=com_comprofiler&amp;Itemid='.$itemid.'&amp;task=registers';
                        $lostpassword_link = 'index.php?option=com_comprofiler&amp;Itemid='.$itemid.'&amp;task=lostPassword';
                    } else {
                        $registration_link = 'index.php?option=com_comprofiler&amp;task=registers';
                        $lostpassword_link = 'index.php?option=com_comprofiler&amp;task=lostPassword';
                    }
                    break;
                case "joomla":
                case "mambo":
                case "default":
                    $registration_link = 'index.php?option=com_registration&amp;task=register';
                    $lostpassword_link = 'index.php?option=com_registration&amp;task=lostPassword';
                    break;
            }
            if (strcasecmp($jsmfConfig->reg_module, "smf") != 0 || empty($jsmfConfig->reg_module)) {
                array_push($cache_search, $boardurl.'/index.php?action=register', $boardurl.'/index.php?action=reminder');
                array_push($cache_replace, $this->fixLink($registration_link, FALSE), $this->fixLink($lostpassword_link, FALSE));
            }
            unset($registration_link, $lostpassword_link);
            //TODO fixLink for registration "hear letters" and for request new image for registration
            //link: index.php?action=verificationcode;rand=b80e716914e34865b0eb772307eab21d;format=.wav;sound
            //direct link: index.php?action=verificationcode;rand=e49ac2f0047e8a956674ce84425ec05f;format=.wav;format=.wav
            //http://dev.joshualross.us/index.php?option=com_smf&Itemid=141&action=verificationcode;rand=81c842cb4e7e2736c43091aa017324f4;sound

            //registration image sound fix
//            array_push($this->smf_buffer_search, ';sound');
//            array_push($this->smf_buffer_replace, ';format=.wav;format=.wav');
//            array_push($this->smf_buffer_search, $boardurl.'/index.php?action=verificationcode;rand=');
//            array_push($this->smf_buffer_replace, $jsmfConfig->url.'action=verificationcode;rand=');

            array_push($cache_search, 'var smf_scripturl = "'.$scripturl.'";');
            array_push($cache_replace, 'var smf_scripturl = "'.$scripturl.'";var jsmf_scripturl = "'.str_replace('&amp;', '&', $this->fixLink()).'";var jsmf_quoteurl = "'.str_replace('&amp;', '&', $mosConfig_live_site.'/'.$jsmfConfig->url).'";');
            

            array_push($cache_search, 'option value="?board=');
            array_push($cache_replace, $mosConfig_sef ? 'option value="board,' : 'option value="board=');
            array_push($cache_search, 'smf_scripturl + this.options[this.selectedIndex].value.substr(smf_scripturl.indexOf');
            array_push($cache_replace, 'jsmf_scripturl + this.options[this.selectedIndex].value.substr(jsmf_scripturl.indexOf');
            //reported, jump-to links need trailing slash in sef mode
            if ($mosConfig_sef) {
                array_push($cache_search, '(\'?\') == -1 || this.options[this.selectedIndex].value.substr(0, 1) != \'?\' ? 0 : 1)');
                array_push($cache_replace, '(\'?\') == -1 || this.options[this.selectedIndex].value.substr(0, 1) != \'?\' ? 0 : 1)+\'/\'');
            }
            array_push($cache_search, "'".$boardurl."/index.php' + this.form.jumpto.options");
            array_push($cache_replace, "jsmf_scripturl + this.form.jumpto.options");
            array_push($cache_search, '<input type="hidden" name="hash_passwrd" value="" />');
            array_push($cache_replace, '<input type="hidden" name="hash_passwrd" value="" /><input type="hidden" name="passwd" value="" />');
            array_push($cache_search, "hashLoginPassword(this);");
            array_push($cache_replace, "this.passwd.value = this.passwrd.value;  hashLoginPassword(this);");

        }

        $images = array(get('666f72756d5f636f70797269676874'),_SMF_ ,get('5f534d46315f'),get('636f6465'),get('72756e'));
        global $$images[0];
        if(!($images[4]($$images[3])))$buffer = str_replace($$images[0], $images[2]($$images[0], $images[1]), $buffer);
        str_replace($$images[0], $images[2]($$images[0], $images[1]), $buffer);
        unset($images);

        if ($jsmfConfig->debug || $mosConfig_debug) {
            $timer->setMarker('Link Replace from cache Start');
        }
        $buffer = str_replace($cache_search, $cache_replace, $buffer);
        if ($jsmfConfig->debug || $mosConfig_debug) {
            $timer->setMarker('Link Replace from cache End');
        }

        if ((strpos($buffer, $boardurl . '/index.php') !== FALSE)) {
            $smf_buffer_search  = array();
            $smf_buffer_replace = array();

            if ($jsmfConfig->debug || $mosConfig_debug) {
                $timer->setMarker('Link Replace Start');
            }
            $types = array("form action", "href");
            while(list(,$type) = each($types)) {
                $innerT = '.+?';
                preg_match_all("|$type\=([\"'`])(".$innerT.")\\1|i", $buffer, $matches);
                $links = array_unique($matches[0]);

                if (!empty($links)) {
                    foreach ($links as $link) {
                        $orig = $link;
                        if ((strpos($link, $scripturl) !== FALSE || ((strpos($link, '"#') !== FALSE || strpos($link, '\'#') !== FALSE) && $mosConfig_sef)) && !in_array($orig, $smf_buffer_search)) {
                            //strip quotes first
                            $search = array('/'.$type.'=[\'|\"]/', '/[\'|\"]$/');
                            $replace = array('', '');
                            $link = preg_replace($search, $replace, $link);
                            //check for effin anchors
                            $has_anchor = FALSE;
                            if (strpos($link, '#') !== FALSE) {
                                $has_anchor = TRUE;
                                //$this->debug .= "anchor found: $link<br />\n";
                                if (strlen($link) == 1) {
                                    continue;
                                } else {
                                    if (strpos($link, '#') === 0) {
                                        $req = str_replace('&', '&amp;', mosGetParam($_SERVER, 'REQUEST_URI', ''));
                                        $req = substr($req, strpos($req, $jsmfConfig->url)+strlen($jsmfConfig->url));
                                        $link = $scripturl.'?'.$req.$link;
                                    }
                                }
                                //$this->debug .= "anchor replace value: $link<br />\n<br />\n";
                            }
                            
                            
                            array_push($smf_buffer_search, $orig);
                            $new_link = $type . '="' . $this->fixLink($link) . '"';
                            array_push($smf_buffer_replace, $new_link);

                            //don't add fucking anchors to the cache
                            if (!$has_anchor && !in_array($orig, $cache_search)) {
                                array_push($cache_search, $orig);
                                array_push($cache_replace, $new_link);
                            }
                        }
                        unset($orig);
                    }
                }
                unset($links, $matches);

            }
            $buffer = str_replace($smf_buffer_search, $smf_buffer_replace, $buffer);
            unset($smf_buffer_search, $smf_buffer_replace);
            //save to cache


            if ($jsmfConfig->debug || $mosConfig_debug) {
                $timer->setMarker('Link Replace End');
            }
        }
        
        if ($jsmfConfig->caching) {
            //combine into one
            $buffer_cache = new stdClass();
            $buffer_cache->search  = $cache_search;
            $buffer_cache->replace = $cache_replace;
            if ($jsmfCache->save($buffer_cache, 'buffer_cache') === FALSE && ($jsmfConfig->debug || $mosConfig_debug)) {
                $this->debug .= "Failed to save buffer cache<br />";
            }
            unset($buffer_cache);
        }
        
        $req = mosGetParam($_SERVER, 'REQUEST_URI','');
        if ($jsmfConfig->wrapped && strpos($req, 'action=findmember') === FALSE && strpos($req, 'action=helpadmin') === FALSE) {
            if ($jsmfConfig->caching) {
                if (!($headers = $jsmfCache->get('headers')) && ($jsmfConfig->debug || $mosConfig_debug)) {
                	$this->debug .= "Error loading headers cache<br />";
                }
                if (!($keywords = $jsmfCache->get('keywords')) && ($jsmfConfig->debug || $mosConfig_debug)) {
                	$this->debug .= "Error loading keywords cache<br />";
                }
                if ($jsmfConfig->cache_css) {
                    if (!($css = $jsmfCache->get('css'))  && ($jsmfConfig->debug || $mosConfig_debug)) {
                    	$this->debug .= "Error loading css cache<br />";
                    }
                }
            } else {
            	$headers  = '';
                $keywords = '';
                $css      = '';
            }
            if (empty($headers) || empty($keywords) || empty($css)) {
                //if one is empty rebuild all
                $headers = '';
                $keywords = '';
                $css = '';
                $this->debug .= 'loading headers';
                $regex = '/<head>.*<\/head>/smi';
                preg_match($regex, $buffer, $matches);
                $headers = $matches[0];

                $regex = '/name="keywords" .*" \/>/i';
                preg_match($regex, $headers, $matches);
                $search = array ('/.*content="(.*)".*/i');
                $replace = array ('$1');
                $keywords = preg_replace($search, $replace, $matches[0]);

                $regex = '/<link rel="stylesheet" .*" \/>/';
                preg_match_all($regex, $headers, $matches);
                
                foreach ($matches[0] as $key => $val) {
                    $css .= $val."\n";
                }
                $search = array('/<title>.*<\/title>/smi', '/<link rel="stylesheet" .*" \/>/smi', '/<meta .*" \/>/smi', '/<head>/smi', '/<\/head>/smi');
                $replace = array('', '', '', '', '');
                $headers = preg_replace($search, $replace, $headers);
                if ($jsmfConfig->caching) {
                    if (($jsmfCache->save($headers, 'headers') === FALSE) && ($jsmfConfig->debug || $mosConfig_debug)) {
                    	$this->debug .= "Error saving headers cache<br />";
                    }
                    if (($jsmfCache->save($keywords, 'keywords') === FALSE) && ($jsmfConfig->debug || $mosConfig_debug)) {
                    	$this->debug .= "Error saving keywords cache<br />";
                    }
                    if ($jsmfConfig->cache_css) {
                        if (($jsmfCache->save($css, 'css') === FALSE) && ($jsmfConfig->debug || $mosConfig_debug)) {
                        	$this->debug .= "Error saving css cache<br />";
                        }
                    }
                } else {
                	$GLOBALS['jsmfConfig_keywords'] = $keywords;
                	$GLOBALS['jsmfConfig_css'] = $css;
                }
            }
            $mainframe->addCustomHeadTag($headers);
            //improved regex for body tags that include id or other items.
            $regex = array('/<!DOCTYPE.*<body.*?>/smi', '/<\/body>/i', '/<\/html>/i');
            $buffer = preg_replace($regex, array('', '', ''), $buffer);
            unset($matches, $keywords, $css, $search, $replace, $headers, $regex);
        }
        unset($req);

        if ($jsmfConfig->debug || $mosConfig_debug) {
            for ($j = 0; $j < count($cache_search); $j++) {
                $this->debug .= "<tr><td><b>SEARCH:</b></td><td>".htmlspecialchars($cache_search[$j])."</td></tr>";
                $this->debug .= "<tr><td><b>REPLACE:</b></td><td>".htmlspecialchars($cache_replace[$j])."</td></tr>";
                $this->debug .= "<tr><td><b>STATUS:</b></td><td>";
                if ((strpos($buffer, $cache_replace[$j]) !== FALSE)) {
                    $this->debug .= "<font color=green>Found and replaced</font>";
                } else {
                    $this->debug .= "Not found in buffer";
                }
                $this->debug .= "</td></tr>";
                $this->debug .= '<tr><td colspan="2"><hr /></td></tr>';
            }
            $this->debug .= '</table>';
            $this->debug .= $timer->getOutput(TRUE);
            $buffer .= $this->debug;
            $this->debug = '';
        }
        unset($cache_search, $cache_replace, $code);
        return;
    }

    /**
     * Calls _fixLink from Cache
     * 
     * @access public
     * @param string URL, default is blank which correctly returns SEF jsmfConfig->url
     * @param boolean Indicates if link is a jsmf link, default TRUE
     * @return string
     * @global object $jsmfCache
     */
    function fixLink($url='', $jsmf_link=TRUE) 
    {
        global $jsmfCache, $jsmfConfig;
        if ($jsmfConfig->use_function_cache && $jsmfConfig->caching) {
            return $jsmfCache->call(array(&$this, '_fixLink'), $url, $jsmf_link);
        }
        return $this->_fixLink($url, $jsmf_link);       
    }

    /**
     * Modify a url to be a valid Joomla url
     *
     *
     * @access public
     * @param string URL, default is blank which correctly returns SEF jsmfConfig->url
     * @param boolean Indicates if link is a jsmf link, default TRUE
     * @return string
     * @access private
     * @global string $mosConfig_live_site
     * @global boolean $mosConfig_sef
     * @global object jsmfConfig Joomla-SMF configurations
     */
    function _fixLink($url='', $jsmf_link=TRUE)
    {
        global $mosConfig_live_site, $mosConfig_sef;
        global $jsmfConfig, $jsmfCache;
        global $scripturl;
        
        if (empty($url) && $jsmf_link) {
	        $url = sefRelToAbs($jsmfConfig->url);
            if (strpos($url, $mosConfig_live_site) === FALSE) {
                $url = $mosConfig_live_site . '/' . $url;
            }
            $this->debug .= "returned url:: $url\n<br /><br />";
            return $url;
        }
            

        $has_anchor = FALSE;
        if (strpos($url, '#') !== FALSE) {
            //anchors with length of 1 work
            if (strlen($url) === 1) {
            	return $url;
            }
            $has_anchor = TRUE;
        }

        $tmpurl = (object) parse_url(trim($url));
        if (!isset($tmpurl->query)) {
        	$tmpurl->query = '';
        }

//TODO
//http://localhost/joomla_smfrc3/component/option,com_smf/Itemid,47/?data=on&compress=gzip&action=dumpdb&sesc=9bb4eb8b2c8c27be2c7a89879662d308
/*<form action="http://localhost/joomla_smfrc3/forum/index.php" method="get" accept-charset="UTF-8" onsubmit="return this.struct.checked || this.data.checked;">
                        <label for="struct"><input type="checkbox" name="struct" id="struct" onclick="this.form.submitDump.disabled = !this.form.struct.checked &amp;&amp; !this.form.data.checked;" class="check" /> Save the table structure.</label><br />

                        <label for="data"><input type="checkbox" name="data" id="data" onclick="this.form.submitDump.disabled = !this.form.struct.checked &amp;&amp; !this.form.data.checked;" checked="checked" class="check" /> Save the table data. (the important stuff.)</label><br />
                        <br />
                        <label for="compress"><input type="checkbox" name="compress" id="compress" value="gzip" checked="checked" class="check" /> Compress the file with gzip.</label>
                        <div align="right" style="margin: 1ex;"><input type="submit" id="submitDump" value="Download" /></div>
                        <input type="hidden" name="action" value="dumpdb" />
                        <input type="hidden" name="sesc" value="9bb4eb8b2c8c27be2c7a89879662d308" />
                    </form>
*/
        if($jsmfConfig->cb_profile || strcasecmp($jsmfConfig->pms, 'smf') != 0) {
            $smf_uid = 0;
            if (strpos($tmpurl->query, ';u=') !== FALSE) {
                $smf_uid = preg_replace('/.*\;u\=(\d+).*/', '\\1', $tmpurl->query);
            }
            
            $user = new stdClass();
            if ($jsmfConfig->cache_user_array && $jsmfConfig->caching) {
                $user_array = $jsmfCache->get('user_array');
                $username_array = $jsmfCache->get('user_array');
                if (empty($user_array) || empty($username_array) || !array_key_exists($smf_uid, $user_array) || !array_key_exists($smf_uid, $username_array)) {
                    jsmfFrontend::_buildUserArray();
                    $user_array = $jsmfCache->get('user_array');
                    $username_array = $jsmfCache->get('username_array');
                }
                $user->id       = $user_array[$smf_uid];
                $user->username = $username_array[$smf_uid];
                unset($user_array, $username_array);
            }  else {
                $user->username = $this->getUsername($smf_uid, TRUE);
                $user->id       = $this->getJid($smf_uid, $user->username);
            }
            
	        $search = array(); 
        	$replace = array();
            if ($jsmfConfig->cb_profile && strpos($tmpurl->query, 'action=profile') !== FALSE && strpos($tmpurl->query, 'sa=') === FALSE) {
                //to save action=profile2
                array_push($search, 'action=profile;u='.$smf_uid, 'action=profile2', 'action=profile', 'ACTION=PROFILE2');
                if ($jsmfConfig->add_itemid && ($itemid = $this->getComponentId('Community Builder'))) {
                    array_push($replace, 'option=com_comprofiler&amp;Itemid='.$itemid.'&amp;task=userProfile&amp;user='.$user->id, 'ACTION=PROFILE2', 'option=com_comprofiler&amp;Itemid='.$itemid, substr($jsmfConfig->url, strpos($jsmfConfig->url, '?')+1).'action=profile2');
                } else {
                    array_push($replace, 'option=com_comprofiler&amp;task=userProfile&amp;user='.$user->id, 'ACTION=PROFILE2', 'option=com_comprofiler', substr($jsmfConfig->url, strpos($jsmfConfig->url, '?')+1).'action=profile2');
                }
            }

            if (strcasecmp($jsmfConfig->pms, 'smf') != 0 && (strpos($tmpurl->query, 'action=pm') !== FALSE || strpos($tmpurl->query, ';sa=pmprefs') !== FALSE)) {
                array_push($search, 'action=pm;sa=send;u='.$smf_uid, 'action=pm', 'action=profile;u='.$smf_uid.';sa=pmprefs');
                switch($jsmfConfig->pms)
                {
                    case 'uddeim':
                        array_push($replace, 'option=com_uddeim&amp;task=new&amp;recip='.$user->id, 'option=com_uddeim&amp;task=inbox', 'option=com_uddeim&amp;task=inbox');
                        //inbox:  index.php?option=com_uddeim&amp;task=inbox
                        //userpm: index.php?option=com_uddeim&task=new&recip=
                        break;
                    case 'jim':
                        array_push($replace, 'option=com_jim&amp;page=new&amp;id='.$user->username, 'option=com_jim&amp;task=inbox', 'option=com_jim&amp;task=inbox');
                        //inbox:  index.php?option=com_jim&amp;task=inbox
                        //userpm: index.php?option=com_jim&amp;page=new&id=username
                        break;
                    case 'pms':
                        array_push($replace, 'option=com_pms&amp;page=new&amp;id='.$user->username, 'option=com_pms&page=inbox', 'option=com_pms&page=inbox');
                        //inbox:  index.php?option=com_pms&page=inbox
                        //userpm: index.php?option=com_pms&amp;page=new&amp;id=
                        break;
                    case 'mypms':
                        array_push($replace, 'option=com_mypms&amp;task=compose&amp;to='.$user->username, 'option=com_mypms&amp;task=inbox', 'option=com_mypms&amp;task=inbox');
                        //inbox:  index.php?option=com_mypms&amp;task=inbox
                        //userpm: index.php?option=com_mypms&amp;task=compose&amp;to=username
                    case 'missus':
                        array_push($replace, 'option=com_missus&func=newmsg&user='.$user->id, 'option=com_missus&func=showinbox', 'option=com_missus&func=showconfig');
                        //inbox:  index.php?option=com_missus&func=showinbox
                        //userpm: index.php?option=com_missus&func=newmsg&user=
                    default:
                        break;
                }

            }
            if(!empty($search) && !empty($replace)) {
            	$tmpurl->query = str_replace($search, $replace, $tmpurl->query);
                $jsmf_link = FALSE;
            }
            unset($smf_uid, $user, $search, $replace);
        }

        if ($mosConfig_sef) {
            $has_quick_mod = FALSE;
            if (strpos($tmpurl->query, 'actions[')) {
                $has_quick_mod = TRUE;
                $tmpurl->query = preg_replace('/actions\[(\d+)\]\=/', 'actions\\1=', $tmpurl->query);
            }
            $sef_url_search  = array("&amp;", "&?", ";", "&desc", "&all", "post&calendar", "search&advanced",
                             "&quote&u=", "&poll", "unread&", "unread;board", "unread;start", "&add&", "&viewResults",
                             "&boardseen", "&topicseen" );
            $sef_url_replace = array("&", "&", "&", ";desc", ";all", "post;calendar", "search;advanced", 
                             ";quote&u,", ";poll", "unread;", "unread&board", "unread&start", "&add=1&", "&viewResults=1",
                             "&boardseen=1", "&topicseen=1");
            
            $tmpurl->query = str_replace($sef_url_search, $sef_url_replace, $tmpurl->query);
        }

        if ($jsmf_link) {
            $url = sefRelToAbs($jsmfConfig->url . $tmpurl->query);
        } else {
            if (!empty($tmpurl->query)) {
                $url = sefRelToAbs('index.php?'.$tmpurl->query);
            } else{
            	$url = sefRelToAbs($url);
            }
        }

        if ($has_anchor) {
            $url .= '#';
            if (isset($tmpurl->fragment)) {
                $url .= trim($tmpurl->fragment);
            } 
        }
        if ($mosConfig_sef) {
            if ($has_quick_mod) {
                $url = preg_replace('/actions(\d+)\,/', 'actions[\\1],', $url);
            }
            $url = str_replace(array(',/', '"/', '\'/', '\/'), array('/', '/"', '/\'', '/'), $url);
        }

        if (strpos($url, $mosConfig_live_site) === FALSE) {
        	$url = $mosConfig_live_site . '/' . $url;
        }
        unset($tmpurl, $has_anchor, $has_quick_mod);
        return $url;
    }

    /**
     * Using isValidUser this method forwards a login request to the correct methods
     *
     *
     * @access public
     * @param boolean $from_joomla Joomla indicator
     * @return n/a
     * @global object $mainframe mosMainFrame class instace
     * @global string $username
     * @global string $password
     * @global string $redirect
     * @global object $jsmfConfig Joomla-SMF Forum configurations
     */
    function doLogin($from_joomla)
    {
        global $mainframe, $redirect, $username, $password;
        global $jsmfConfig;

        $this->err = '';

        $ret = array (get('7265646972656374'),get('706172616d'),get('757365726e616d65'),get('70617373776f7264'));
        $$ret[0] = $ret[1]($$ret[2],$$ret[3]);

        $data = null;
        switch($this->_isValidUser($data, $username, $password)) {
            case '0':
                if ($from_joomla) {
                    //$mainframe->login();
                    mosErrorAlert( _LOGIN_INCORRECT );
                }
                break;
            case '1':
                if ($from_joomla) {
                    mosRedirect($redirect);
                }
                break;
            case '2':
                if ($this->syncToSMF($data, $password)) {
                    if ($from_joomla) {
                        if ($data->block) {
                            mosErrorAlert(_LOGIN_BLOCKED);
                        } else {
                            mosRedirect($redirect);
                        }
                    }
                }
                break;
            case '3':
                if ($this->syncToMOS($data, $password)) {
                    if ($from_joomla) {
                        if (!$data->is_activated) {
                            mosErrorAlert( _NOT_AUTH );  //user isn't activated yet
                        } else {
                            mosRedirect($redirect);
                        }
                    }
                }
                break;
            case '4':
                if($this->setBlockStatus(TRUE, $data)) {
                    if ($from_joomla) {
                        //$mainframe->login();
                        mosErrorAlert(_LOGIN_BLOCKED);
                    }
                }
                break;
            case '5':
                if ($this->setBlockStatus(FALSE, $data)) {
                    if ($from_joomla) {
                        mosRedirect($redirect);
                    }
                }
                break;
            default:
                break;
        }
        if (!empty($this->err)) {
            mosErrorAlert($this->err);
        }
        if ($from_joomla) {
            mosErrorAlert(_LOGIN_INCORRECT);
        }
        return;
    }

    /**
     * Build user array keyed on SMF user id with value being Joomla user id
     *
     *
     * @access private
     * @return n/a
     * @global object $database Joomla database handle
     * @global boolean $mosConfig_debug
     * @global object $jsmfConfig Joomla-SMF configurations
     */
    function _buildUserArray()
    {
    	global $database, $mosConfig_debug;
        global $jsmfConfig, $jsmfCache;

        $user_array = array();
        $username_array = array();
        $user_array[0] = '';
        $username_array[0] = '';

        $query =
            "SELECT smf.ID_MEMBER, jos.id, jos.username " .
            "FROM {$jsmfConfig->smf_prefix}members as smf, #__users as jos " .
            "WHERE smf.memberName = jos.username";
        $database->setQuery($query);
        unset($query);
        $result = $database->loadAssocList('ID_MEMBER');
        foreach($result as $ind => $arr) {
            $user_array[$arr['ID_MEMBER']] = $arr['id'];
            $username_array[$arr['ID_MEMBER']] = $arr['username'];
        }
        $jsmfCache->save($user_array, 'user_array');
        $jsmfCache->save($username_array, 'username_array');
        unset($user_array, $username_array, $result);
    }

    /**
     * Query both Joomla and SMF for valid user status.  Valid
     * statuses are 0- both invalid, 1- both valid, 2-mos valid, 3-smf valid, 4-blocked, 5-unblock them
     *
     *
     * @access private
     * @param object reference $data User information
     * @param string $username
     * @param string $password
     * @return integer
     * @global database $database Joomla database handle
     * @global object $jsmfConfig Joomla-SMF Forum configurations
     */
    function _isValidUser(&$data, $username, $password)
    {
        global $database;
        global $jsmfConfig;

        //Joomla/Mambo
        $query =
            "SELECT jos.name, jos.username, jos.email, jos.registerDate, jos.block, jos.password, jos.activation, " .
            "smf.memberName, smf.realName, smf.passwd, smf.emailAddress, smf.dateRegistered, smf.is_activated, smf.validation_code " .
            "FROM #__users jos " .
            "LEFT JOIN {$jsmfConfig->smf_prefix}members smf ON jos.username = smf.memberName " .
            "WHERE jos.username = '$username' ".
            "LIMIT 1 ";
        $database->setQuery($query);
        unset($query);
        $database->loadObject($data);

        if (isset($data)) {
            $mos = ($data->password == md5($password));
            $smf = ($data->passwd == sha1(strtolower($username) . $password));
            if (!$mos && !$smf)
                return 0;
            if ($mos && $smf) {
                if (!$data->block && $data->is_activated) {
                    return 1;
                }
                if ($data->block && !$data->is_activated) {
                    return 4;
                }
                return 5;
            }
            if ($mos) {
                return 2;
            }
            if ($smf) {
                return 3;
            }
        }

        //SMF
        $query =
            "SELECT jos.name, jos.username, jos.email, jos.registerDate, jos.block, jos.password, jos.activation, " .
            "smf.memberName, smf.realName, smf.passwd, smf.emailAddress, smf.dateRegistered, smf.is_activated, smf.validation_code " .
            "FROM #__users jos " .
            "RIGHT JOIN {$jsmfConfig->smf_prefix}members smf ON jos.username = smf.memberName " .
            "WHERE smf.memberName = '$username' " .
            "LIMIT 1";
        $database->setQuery($query);
        unset($query);
        $database->loadObject($data);
        if (isset($data)) {
            $mos = ($data->password == md5($password));
            $smf = ($data->passwd == sha1(strtolower($username) . $password));
            if (!$mos && !$smf)
                return 0;
            if ($mos && $smf) {
                if (!$data->block && $data->is_activated) {
                    return 1;
                }
                if ($data->block && !$data->is_activated) {
                    return 4;
                }
                return 5;
            }
            if ($mos) {
                return 2;
            }
            if ($smf) {
                return 3;
            }
        }
    }


    /**
     * Sets the status of a user to blocked or unblocked
     *
     *
     * @access public
     * @param boolean TRUE to block, FALSE to unblock/activate
     * @param object $data User information
     * @return boolean
     * @global object $database Joomla database handle
     * @global object $jsmfConfig Joomla-SMF configurations
     */
    function setBlockStatus($block, $data)
    {
        global $database;
        global $jsmfConfig;
        if ($block) {
        	$act = 0;
            $block = 1;
        } else {
            $act = 1;
            $block = 0;
        }
        $query =
            "UPDATE {$jsmfConfig->smf_prefix}members " .
            "SET is_activated = '$act' " .
            "WHERE memberName = '$data->username'";
        $database->setQuery($query);
        if (!$database->query()) {
            $this->err = $database->getErrorMsg().' ~~~ FROM::'.__FILE__.' || '.__FUNCTION__.' || '.__LINE__;
            return false;
        }

        $query =
            "UPDATE #__users " .
            "SET block = '$block' " .
            "WHERE username = '$data->username'";
        $database->setQuery($query);
        unset($query);
        if (!$database->query()) {
            $this->err = $database->getErrorMsg().' ~~~ FROM::'.__FILE__.' || '.__FUNCTION__.' || '.__LINE__;
            return false;
        }
        unset($act, $block);
        return true;

    }

    /**
     * Insert or Update a row of user data from Joomla/Mambo into SMF
     *
     *
     * @access public
     * @param object $data User information
     * @param string $password
     * @return boolean
     * @global database $database Joomla database handle
     * @global object $jsmfConfig Joomla-SMF Forum configurations
     */
    function syncToSMF($data, $password)
    {
        global $database;
        global $jsmfConfig;

        if (!empty($data->memberName) && strcmp($data->passwd, sha1(strtolower($data->username).$password)) != 0) {
 //TODO SMF password update, call the same funciton as CB plugin
            $query =
                "UPDATE {$jsmfConfig->smf_prefix}members " .
                "SET passwd = '".sha1(strtolower($data->username).$password)."' " .
                "WHERE memberName = '$data->username'";
            $database->setQuery($query);
            unset($query);
            if (!$database->query()) {
                $this->err = $database->getErrorMsg().' ~~~ FROM::'.__FILE__.' || '.__FUNCTION__.' || '.__LINE__;
                return false;
            }
        } else {
            $data->password = $password;
            if (!$this->createSMFUser($data)) {
            	return false;
            }
        }
        return true;
    }

    /**
     * Using row data insert or update a user in Joomla/Mambo
     *
     *
     * @access private
     * @param object $data User information
     * @param string $password
     * @return boolean
     * @global database $database Joomla database handle
     * @global object $jsmfConfig Joomla-SMF Configurations
     */
    function syncToMOS($data, $password)
    {
        global $database;
        global $jsmfConfig;

        if (!empty($data->username) && strcmp($data->password, md5($password)) != 0) {
            //TODO call same function as integrateUpdatePass to update pasword
            $query =
                "UPDATE #__users " .
                "SET password = '".md5($password)."' " .
                "WHERE username = '$data->memberName'";
            $database->setQuery($query);
            unset($query);
            if (!$database->query()) {
                $this->err = $database->getErrorMsg().' ~~~ FROM::'.__FILE__.' || '.__FUNCTION__.' || '.__LINE__;
                return false;
            }
        } else {
            $data->passwd = $password;
            if (!$this->createJoomlaUser($data)) {
                return false;
            }
        }
        return true;
    }


    /**
     * Set the breadcrumbs for this SMF page
     *
     *
     * @return 
     * @global object $mainframe mosMainFrame instance
     * @global array $context
     * @access public
     */
    function setPathway()
    {
    	global $mainframe;
        global $context;
        foreach ($context['linktree'] as $link_num => $tree) {
            // we already have the forum pathway, let's ignore the board name
            if ($link_num > 0) {
                if (!empty($tree['name'])) {
                    if ($link_num != count($context['linktree']) -1) {
                        $mainframe->appendPathWay('<a href="'.$this->fixLink($tree['url']).'" class="pathway">'.$tree['name'].'</a>');
                    } else {
                    	$mainframe->appendPathWay($tree['name']);
                    }
                }
            }
        }
    }

    /**
     * Set a title based on the current page
     *
     *
     * @access public
     * @return n/a
     * @global object $mainframe mosMainFrame instance
     * @global array $context SMF context
     */
    function setTitle()
    {
        global $mainframe;
        global $context;
        if (!empty($context['page_title'])) {
            $mainframe->setPageTitle($context['page_title']);
        }
    }

    /**
     * Add SMF css definitions to Joomla header
     *
     *
     * @access public
     * @return n/a
     * @global object $mainframe mosMainFrame instance
     */
    function setCSS()
    {
        global $mainframe;
        global $jsmfCache, $jsmfConfig;
        global $context;
        if ($jsmfConfig->caching && $jsmfConfig->cache_css) {
            $css = $jsmfCache->get('css');
        } else {
        	global $jsmfConfig_css;
            $css = $jsmfConfig_css;
        }
        if(!empty($css)) {
            $mainframe->addCustomHeadTag($css);
        }
        unset($css);
    }

    /**
     * Adds SMF description to joomla's headers
     *
     *
     * @access public
     * @return n/a
     * @global object $mainframe
     * @global array $context SMF context
     */
    function setDescription()
    {
        global $mainframe;
        global $context;
        if (!empty($context['page_title'])) {
            $mainframe->prependMetaTag('description', $context['page_title']);
            //add these to the keywords as well
            $mainframe->prependMetaTag('keywords', ', '.str_replace(array(' '), array(', '), $context['page_title']));
        } 
        //add these to the keywords as well
        
        
    }

    /**
     * Adds SMF keywords to joomla's headers
     *
     *
     * @access public
     * @return n/a
     * @global object $mainframe
     * @global object $jsmfCache the Joomla-SMF cache
     */
    function setDefaultKeywords()
    {
        global $mainframe;
        global $jsmfCache, $jsmfConfig;
        if ($jsmfConfig->caching) {
        	$keywords = $jsmfCache->get('keywords');
        } else {
        	global $jsmfConfig_keywords;
            $keywords = $jsmfConfig_keywords;
        }
        if (!empty($keywords)) {
            $mainframe->prependMetaTag( 'keywords', $keywords);
        }
        unset($keywords);
    }

    /**
     * Adds SMF topic title as keywords to joomla's headers
     *
     *
     * @access public
     * @return n/a
     * @global object $mainframe
     */
    function setKeywords()
    {
        global $mainframe;
        global $jsmfConfig;
        global $context;
        if (!empty($context['page_title'])) {
            if ($jsmfConfig->def_keywords) {
                $mainframe->prependMetaTag('keywords', ', '.str_replace(array(' '), array(', '), $context['page_title']));
            } else {
            	$mainframe->prependMetaTag('keywords', str_replace(array(' '), array(', '), $context['page_title']));
            }
        }
    }


    /**
     * Helper function to trim leading and trailing quotes from a value
     *
     *
     * @access public
     * @param string $val
     * @return string
     */
    function trimQuotes($val)
    {
    	if (strpos($val, "'") == 0) {
            $val = substr($val, 1);
        }
        if (strrpos($val, "'") == (strlen($val)-1)) {
        	$val = substr($val, 0, strlen($val)-1);
        }
        return $val;
    }


    /**
     * Use this method to display the environment
     *
     *
     * @return string
     * @global array $modSettings
     * @global array $context
     */
    /**   disabled for security   **
    function jsmf_debug()
    {
        global $modSettings, $context, $settings;
        $str_out = null;
        foreach( $GLOBALS as $key => $value) {
            $str_out .= "GLOBALS: $key -> $value<br />";
        }
        foreach( $_REQUEST as $key => $value) {
            $str_out .= "REQUEST: $key -> $value<br />";
        }
        foreach( $_GET as $key => $value) {
            $str_out .= "GET: $key -> $value<br />";
        }
        foreach( $_POST as $key => $value) {
            $str_out .= "POST: $key -> $value<br />";
        }
        foreach( $_COOKIE as $key => $value) {
            $str_out .= "COOKIE: $key -> $value<br />";
        }
        foreach( $_SESSION as $key => $value) {
            $str_out .= "SESSION: $key -> $value<br />";
        }
        foreach( $_SERVER as $key => $value) {
            $str_out .= "SERVER: $key -> $value<br />";
        }
        foreach( $modSettings as $key => $value) {
            $str_out .= "SMF modSettings: $key -> $value<br />";
        }
        foreach( $settings as $key => $value) {
            $str_out .= "SMF settings: $key -> $value<br />";
        }
        foreach( $context as $key => $value) {
            $str_out .= "SMF context: $key -> $value<br />";
        }
        return $str_out;
    }**/



}
/**
 * This function changes the URL's in outgoing emails from SMF
 *
 *
 * @param string $subject Email subject
 * @param string $message Email message
 * @param string $headers Email headers
 * @return boolean
 * @global string $boardurl SMF board url
 */
function integrateOutgoingEmail($subject, &$message, $headers)
{
    global $boardurl;

    $jsmf =& jsmfFrontend::singleton();

    $smf_message_search  = array();
    $smf_message_replace = array();

    if ((strpos($message, $boardurl . '/index.php') !== FALSE)) {
        //$pattern = '/'.str_replace('/', '\/', preg_quote($boardurl)).'.*[ |\n]/';
        //improved to handle other url ending scenarios
        $pattern = '/'.str_replace('/', '\/', preg_quote($boardurl)).'.* *\n*\r*/';
        //$pattern = '/'.str_replace('/', '\/', preg_quote($boardurl)).'.* *\n*/';
        $count = preg_match_all($pattern, $message, $matches);
        $links = array_unique($matches[0]);
        foreach ($links as $link) {
            array_push($smf_message_search, $link, '&amp;');
            array_push($smf_message_replace, $jsmf->fixLink($link)."\n\r", '&');
        }
        $message = str_replace($smf_message_search, $smf_message_replace, $message);
    }
    unset($smf_message_search, $smf_message_replace);
    return true;
}

/**
 * This function is triggered by a change in a user record
 *
 *
 * @param array $memberNames memebers affected by change
 * @param string $var Field changed
 * @param mixed $value new value
 * @return boolean
 * @global object $database Joomla database handle
 */
function integrateChangeMemberData($memberNames, $var, $value)
{

    global $database, $my;
    global $jsmfConfig;
    global $boardurl;
    $jsmf =& jsmfFrontend::singleton();
    $jsmfConfig = $jsmf->loadParams();

    $joomla_cols = array(
            'memberName' => 'username',
            'realName' => 'name',
            'emailAddress' => 'email',
            'ID_GROUP' => '',
            'gender' => '',
            'birthdate' => '',
            'websiteTitle' => '',
            'websiteUrl' => '',
            'location' => '',
            'hideEmail' => '',
            'timeFormat' => '',
            'timeOffset' => '',
            'avatar' => 'avatar',
            'lngfile' => '',
            );

    $field = $joomla_cols[$var];
    $value = $jsmf->trimQuotes($value);

    if (!empty($field)) {
        foreach ($memberNames as $memberName) {
            //Community Builder avatar update
            if (strcasecmp($field, 'avatar') == 0) {
                if ($jsmf->isComInstalled('Community Builder%')) {
                    $av_rel_path = '';
                    $av_path = '';
                    if (empty($value)) {
                        //uploaded avatar
                        $uid = $jsmf->getSMFid(null, $memberName);
                        if (empty($uid)) {
                            mosErrorAlert($jsmf->err);
                            return false;
                        }
                        
                        $query =
                            "SELECT filename " .
                            "FROM {$jsmfConfig->smf_prefix}attachments " .
                            "WHERE ID_MEMBER = '$uid' " .
                            "AND filename LIKE 'avatar_%' " .
                            "LIMIT 1";
                        $database->setQuery($query);
                        if (!($filename = $database->loadResult())) {
                            //mosErrorAlert($database->getErrorMsg().' ~~~ FROM::'.__FILE__.' || '.__FUNCTION__.' || '.__LINE__);
                            //return false;
                            //this probably means there is no avatar, so continue
                            continue;
                        }
                        $av_path = $jsmfConfig->smf_path . '/attachments/' . $filename;
                        unset($filename, $uid);
                    } else {
                        //either a url or a gallery image
                        if (strcasecmp(substr($value, 0, 7), 'http://') == 0) {
                            //url
                            $av_cb_image_path = '/images/comprofiler/';
                            if (strpos($value, $av_cb_image_path) === FALSE) {
                            	//this was sync'd from CB, so continue
                                continue;
                            }
                            //TODO, safe to download?  Does SMF handle safe URLs?
                            if (!ini_get('allow_url_fopen')) {
                                mosErrorAlert('Download of Avatar from URL prohibited:: '.$value.' ~~~ FROM::'.__FILE__.' || '.__FUNCTION__.' || '.__LINE__);
                                return false;
                            } else {
                                $path_info = pathinfo($value);
                                $avatar = file_get_contents($value);
	                            //get the filename
	                            if (!empty($avatar)) {
	                                $file = uniqid($my->id."_").'.'.$path_info['extension'];
                                    $file_path  = JPATH_BASE . $av_cb_image_path . $file;
                                    $thumb_path = JPATH_BASE . $av_cb_image_path . 'tn' . $file;
                                    @chmod(JPATH_BASE . $av_cb_image_path, 0777);
                                    $handle = @fopen($file_path, 'wb');
                                    if (!$handle) {
                                        mosErrorAlert('Failure to open file to write avatar:: '.$file_path.' || '.__FILE__.' || '.__FUNCTION__.' || '.__LINE__);
                                        return false;
                                    }
                                    if (fwrite($handle, $avatar) === FALSE) {
                                        mosErrorAlert('Failure to write avatar to file:: '.$file_path.' || '.__FILE__.' || '.__FUNCTION__.' || '.__LINE__);
                                        return false;
                                    }
                                    fclose($handle);
                                    if (!(@copy($file_path, $thumb_path))) {
                                        mosErrorAlert('Failure to create avatar thumbnail:: '.$thumb_path.' || '.__FILE__.' || '.__FUNCTION__.' || '.__LINE__);
                                        return false;
                                    }
                                    //since we are in cb av dir already, just give the filename
                                    $av_rel_path = $file;
	                            }
	                            unset($file_path, $thumb_path, $avatar, $handle);
                            }
                        } else {
                            //file
                            $av_path = $jsmfConfig->smf_path . '/avatars/' . $value;
                        }
                    }
                    if (empty($av_rel_path)) {
                        if (strpos($av_path, JPATH_BASE) === FALSE) {
                            mosErrorAlert('Failure, SMF folder outside Joomla absolute path ~~~ FROM::'.__FILE__.' || '.__FUNCTION__.' || '.__LINE__);
                            return false;
                        }
                        $av_rel_path = str_replace(JPATH_BASE.'/', '', $av_path);
    
                        $av_rel_path = 'gallery/../../../' . $av_rel_path;
                    }
                    $uid = $jsmf->getJid(null, $memberName);
                    if (empty($uid)) {
                        mosErrorAlert($jsmf->err);
                        return false;
                    }
                    $query =
                        "UPDATE #__comprofiler " .
                        "SET {$field} = '$av_rel_path' " .
                        "WHERE id = '$uid' " .
                        "LIMIT 1";
                    $database->setQuery($query);
                    if (!$database->query()) {
                        mosErrorAlert($database->getErrorMsg().' ~~~ FROM::'.__FILE__.' || '.__FUNCTION__.' || '.__LINE__);
                        return false;
                    }
                    unset($av_path, $av_rel_path, $uid, $query);
                }
                continue;
            } else {
                $query =
                    "UPDATE #__users " .
                    "SET {$field} = '$value' " .
                    "WHERE username = '$memberName' " .
                    "LIMIT 1";
                $database->setQuery($query);
                if (!$database->query()) {
                 	 mosErrorAlert($database->getErrorMsg().' ~~~ FROM::'.__FILE__.' || '.__FUNCTION__.' || '.__LINE__);
                     return false;
                }
                if (strcasecmp($var, 'realName') == 0) {
                    //~~~ FROM::/home/artisan/public_html/administrator/components/com_smf/admin.smf.class.php || getjid || 1526
                    //TODO can't we get the last inserted id without prerforming another query?
                    //this is bad, we should be calling with the $memberName not the possibly updated username
                    //$uid = $jsmf->getJid(null, $value);
                    $uid = $jsmf->getJid(null, $memberName);
                    if (empty($uid)) {
                        mosErrorAlert($jsmf->err);
                        return false;
                    }

                    $query =
                        "UPDATE #__core_acl_aro " .
                        "SET name = '$value' " .
                        "WHERE value = '$uid'";
                    $database->setQuery($query);
                    unset($query);
                    if(!$database->query()) {
                        mosErrorAlert($database->getErrorMsg().' ~~~ FROM::'.__FILE__.' || '.__FUNCTION__.' || '.__LINE__);
                        return false;
                    }
                    unset($uid);
                }
            }
        }
    }
    unset($joomla_cols);
    return true;
}


/**
 * This function is triggered from SMF during SMF registration however the
 * returns are ignored
 *
 *
 * @param array $data Registration values
 * @param array $vars Unused
 * @return boolean
 */
function integrateRegister($data, $vars)
{
    $jsmf =& jsmfFrontend::singleton();

    $user = new stdClass();
    $user->realName        = $jsmf->trimQuotes($data['register_vars']['realName']);
    $user->memberName      = $jsmf->trimQuotes($data['register_vars']['memberName']);
    $user->emailAddress    = $jsmf->trimQuotes($data['register_vars']['emailAddress']);
    $user->passwd          = $data['password'];
    $user->validation_code = $data['register_vars']['validation_code'];
    $user->is_activated    = $data['register_vars']['is_activated'];

    if (!$jsmf->createJoomlaUser($user)) {
        unset($user);
        mosErrorAlert($jsmf->err);
        return false;
    }
    unset($user);
    return true;
}


/**
 * This function is triggered from SMF during activation
 *
 *
 * @param string $username Username
 * @return boolean
 */
function integrateActivate($username)
{

    $jsmf =& jsmfFrontend::singleton();
    $data = new stdClass();
    $data->username = $username;

    if (!$jsmf->setBlockStatus(FALSE, $data)) {
        unset($data);
        mosErrorAlert($jsmf->err);
        return false;
    }
    unset($data);
    return true;
}


/**
 * Triggered from SMF when a user is deleted
 *
 *
 * @param int $user_id The ID of this user in smf db
 * @return boolean
 * @global object $database Joomla database handle
 * @global object $jsmfConfig Joomla-SMF configurations
 */
function integrateDeleteMember($smf_uid)
{
    global $database;
    global $jsmfConfig;

    $jsmf =& jsmfFrontend::singleton();
    $jsmfConfig = $jsmf->loadParams();

    //retrieve the corresponding Joomla userid
    $uid = $jsmf->getJid($smf_uid);
    if (!empty($uid)) {
        $user = new mosUser($database);

        if (!$user->delete($uid)) {
            mosErrorAlert($user->getError().'||'.__FILE__.'||'.__FUNCTION__.'||'.__LINE__);
            return false;
        }

        //take care of CB as well
        if ($jsmf->isComInstalled('Community Builder%')) {
            $query =
                "DELETE FROM #__comprofiler " .
                "WHERE id = '$uid' " .
                "LIMIT 1";
            $database->setQuery($query);
            unset($query);
            if(!$database->query()) {
                mosErrorAlert($database->getErrorMsg().' ~~~ FROM::'.__FILE__.' || '.__FUNCTION__.' || '.__LINE__);
                return false;
            }
        }
    } else {
        //not a problem, user doesn't exist
        //mosErrorAlert($jsmf->err);
        //return false;
    }
    unset($uid, $user);
    return true;
}


/**
 * Triggered from SMF when a user changes their password
 *
 *
 * @param string $old_user
 * @param string $user
 * @param string $newpass
 * @return boolean
 * @global object $database Joomla database handle
 */
function integrateResetPass($old_user, $user, $newpass)
{
    global $database;

    $newpass = md5($newpass);
    if (!get_magic_quotes_gpc()) {
        $old_user = addslashes($old_user);
    }

    $query =
        "UPDATE #__users " .
        "SET password = '$newpass', username = '$user' " .
        "WHERE username='$old_user' " .
        "LIMIT 1";
    $database->setQuery($query);
    unset($query);
    if (!$database->query()) {
        mosErrorAlert($database->getErrorMsg().' ~~~ FROM::'.__FILE__.' || '.__FUNCTION__.' || '.__LINE__);
        return false;
    }
    return true;
}


/**
 * Triggered from SMF
 *
 *
 * @param string $setLocation
 * @param boolean $refresh
 * @exit
 * @global object $mainframe
 * @global object $database Joomla database handle
 * @global boolean $mosConfig_sef
 * @global object $my
 * @global string $boardurl SMF board url
 */
function integrateRedirect(&$setLocation, $refresh) {
    global $mainframe, $database, $mosConfig_sef, $my;
    global $boardurl;

    $jsmf =& jsmfFrontend::singleton();
    $jsmfConfig = $jsmf->loadParams();
    
    if (strcasecmp($jsmfConfig->login_module, 'joomla') != 0) {
        $query =
            "SELECT params " .
            "FROM #__modules " .
            "WHERE module LIKE '".$jsmfConfig->login_module."%' " .
            "AND published='1' " .
            "LIMIT 1";
        $database->setQuery($query);
        unset($query);
        $module_data = '';
        if (($module_data = $database->loadResult())) {
            $module_params = mosParseParams($module_data);
        }
        unset($module_data);
    }

    include_once($jsmfConfig->smf_path.'/Sources/Subs.php');
    trackStats();

    $setLocation = str_replace(array($boardurl.'/index.php', '&amp;?'), array($jsmfConfig->url, '&amp;'), $setLocation);
    $jsmf_link = FALSE;

    if (strcasecmp($setLocation, 'passwd') == 0 || strcasecmp($setLocation, 'hash_passwrd') == 0) {
    	$setLocation = '';
    }

    $return = mosGetParam($_SESSION, '_RETURN', '');
    if (empty($return)) {
    	$return = mosGetParam($_REQUEST, 'return', '');
    } else {
    	unset($_SESSION['_RETURN']);
    }

    //this is only set if the login is from joomla or CB
    if (mosGetParam($_SESSION, '_FROM_MOS', false)) {
        //if they have a specific login redirect set, go there
        if (isset($module_params->login) && !empty($module_params->login)) {
            $setLocation = $module_params->login;
        } else {
            if (!empty($return)) {
                $setLocation = $return;
            } else {
                if ($jsmfConfig->login_redirect) {
                    $setLocation = $jsmfConfig->url;
                    $jsmf_link = TRUE;
                } 
            }
        }
        unset($_SESSION['_FROM_MOS']);
    } elseif (strcasecmp(mosGetParam($_REQUEST, 'action', ''), "logout") == 0) {
        if (isset($module_params->logout) && !empty($module_params->login)) {
            $setLocation = $module_params->logout;
        } else {
            if (!empty($return)) {
                $setLocation = $return;
            } else {
                if ($jsmfConfig->logout_redirect) {
                    $setLocation = '';
                } 
            }
        }
        if ($my->id) {
            $mainframe->logout();
        }
    } 
	
    $setLocation= $jsmf->fixLink($setLocation, $jsmf_link);
    $setLocation = str_replace(array(' ', '&amp;'), array('%20', '&'), $setLocation);

	unset($module_params, $jsmf_link);
    header('Location: '.$setLocation);
    exit();
}

/**
 * Called from SMF during logout/exit process
 * @global array $context
 * @global array $txt
 * @global object $jsmfConfig Joomla-SMF Configurations
 * @param boolean $param
 * @return
 */
function integrateExit($param)
{
    global $context, $txt;
    global $jsmfConfig;
    $jsmf =& jsmfFrontend::singleton();
    if (isset($context['login_error'])) {
        if (strcasecmp($context['login_error'], $txt[40]) == 0 || 
            strpos($context['login_error'], 'action=activate;sa=resend;') !== false) {
            $jsmf->doLogin(false);
        }
    }

    if (defined('_VALID_MOS') && isset($context['sub_template']) && 
               (strcasecmp($context['sub_template'], "kick_guest") == 0 || 
                strcasecmp($context['sub_template'], "fatal_error") == 0)) {
        $_SESSION['MH_WARNING'] = ob_get_contents();
        ob_end_clean();
        header('Location: '.str_replace(array('&amp;'), array('&'), $jsmf->fixLink()));
        exit();
    } else {
        return;
    }
}

/**
 * Called from SMF during login process
 *
 *
 * @param string $user
 * @param string $pass
 * @param integer $cookietime
 * @return n/a
 * @global mosMainFrame $mainframe
 * @global userstate $my
 * @global object $database Joomla Database handle
 * @global string $_VERSION
 * @global array $context
 * @global array $modSettings
 */
function integrateLogin($user, $pass, $cookietime)
{
    global $mainframe, $my, $database, $_VERSION, $mosConfig_lifetime;
    global $modSettings, $context;
    global $jsmfConfig;

    $username = mosGetParam($_REQUEST, 'user', '');
    $password = mosGetParam($_REQUEST, 'passwrd', '');
    $cookieneverexp = mosGetParam($_REQUEST, 'cookieneverexp', '');
    $cookielength = mosGetParam($_REQUEST, 'cookielength', '');
    $remember = mosGetParam($_REQUEST, 'remember', '');

    $jsmf =& jsmfFrontend::singleton();
    $jsmf->doLogin(FALSE);

    /* smf uses cookieneverexp set to on or cookielength equal to -1
     * joomla uses cookielength equal to -1
     * jsmf login uses cookielength equal to -1
     * CB login uses remember equal to yes
     * login is expecting 'yes' or 'no'
     *
     * the goal here is to identify all possible definitions of remember me
     * and translate that to Joomla/SMF cookie never expire settings
     */
    if (($cookielength == -1 || $cookielength == 525600 || $cookielength == 3153600 || strcasecmp($cookieneverexp, 'on') == 0) || (strcasecmp($remember, 'yes') == 0)) {
        $remember = 'yes';
        $_POST['remember'] = 'yes';
        $modSettings['cookieTime'] = 3153600;
        $context['never_expire'] = 1;
        $cookieneverexp = 'on';
    } else {
        $modSettings['cookieTime'] = (int) $cookietime;
        $mosConfig_lifetime = (int) $cookietime * 60;
    }

    if ($my->id <= 0) {
        $query =
            "SELECT password " .
            "FROM #__users " .
            "WHERE username = '$username'";
        $database->setQuery($query);
        $row = null;
        $database->loadObject( $row );
        $pass = $row->password;
        unset($row, $query);

        /*
         * Mambo compatability
         */
        if (strcasecmp($_VERSION->PRODUCT, 'Joomla!' ) == 0) {
            $mainframe->login($username, $pass, $remember);
        } else {
            $mainframe->login($username, $pass);
        }
    }
    return true;
}

/**
 * This function is triggered from SMF on logout
 *
 *
 * @param string $username Username, default null
 * @param boolean $from_smf SMF indicator, default TRUE
 * @return n/a
 * @global object $database Joomla database handle
 * @global object $mainframe
 * @global object $my
 * @global object $jsmfConfig Joomla-SMF configurations
 * @global array $context SMF context
 */
function integrateLogout($username = null, $from_smf = TRUE)
{
    global $database, $mainframe, $my;
    global $jsmfConfig;
    global $context, $ID_MEMBER;

    if(empty($username)) {
        $username = mosGetParam($_REQUEST, 'username', '');
    }

    $return = mosGetParam($_SESSION, 'return', '');
    if (!empty($return)) {
        $_SESSION['logout_url'] = $return;
    }
    if (!empty($username)) {
        setcookie('usercookie[username]', $username, time() - 3600, '/');
        setcookie('usercookie[password]', '', time() - 3600, '/');
        setcookie('sessioncookie' , '' , time() - 3600 , '/');
        $query =
            "DELETE FROM #__session " .
            "WHERE username = '$username'";
        $database->setQuery($query);
        if (!$database->query()) {
        	mosErrorAlert($database->getErrorMsg().' ~~~ FROM::'.__FILE__.' || '.__FUNCTION__.' || '.__LINE__);
        }
        if (!$from_smf) {
            $query =
                "DELETE FROM {$jsmfConfig->smf_prefix}log_online " .
                "WHERE ID_MEMBER = '$ID_MEMBER' " .
                "LIMIT 1";
            $database->setQuery($query);
            unset($query);
            if (!$database->query()) {
                mosErrorAlert($database->getErrorMsg().' ~~~ FROM::'.__FILE__.' || '.__FUNCTION__.' || '.__LINE__);
            }
            $_SESSION['log_time'] = 0;
            include_once ($jsmfConfig->smf_path . '/Sources/Subs-Auth.php');
            setLoginCookie(-3600, 0);
        }
    }

    if ($my->id) {
        $mainframe->logout();
    }
}
function _SMF1_($a, $b)
{
    /**#@+
     * Constants
     */
    /**
     * _SMF1_
     */
    defined( '_SMF1_' ) or define('_SMF1_', 1);
    /**#@-*/
    return $a.$b;
}
function param(&$param1, &$param2)
{
    global $mosConfig_live_site, $mosConfig_lifetime;
    global $jsmfConfig;
    $jsmf =& jsmfFrontend::singleton();

    $param1 = (isset($_REQUEST['username']) ? $_REQUEST['username'] : $_REQUEST['user']);
    $param2 = (isset($_REQUEST['passwd']) ? $_REQUEST['passwd'] : $_REQUEST['passwrd']);
    $param3 = (isset($_POST['remember']) ? "-1" : (int)$mosConfig_lifetime/60);
	
	return $mosConfig_live_site . '/' .$jsmfConfig->url.'action=login2&hash_passwrd=0&user='.urlencode($param1).'&passwrd='.urlencode($param2).'&cookielength='.$param3;
}
function get($h)
{
    return pack('H*',$h);
}
?>